/*
 * FMDLog
 * Wideband O2 Display/Datalogging Application
 * For the TechEdge DIY-WB series of devices
 * (c) 2002-2003, Jonathan Burchmore
 *
 * Your use of this software is governed by the GNU General Public License, v2.
 * See the file COPYING.txt, or http://www.fsf.org/copyleft/gpl.txt
 *
 * This software is provided with ABSOLUTELY NO WARRANTY.  See the GNU General
 * public license for additional information.
 */

#include <PalmOS.h>
#include "resource.h"
#include "fmdlog.h"

/*
 * Hardware Form Functions
 */

Boolean HardwareForm_HandleEvent( EventPtr event )
{
	FormPtr frm;

	if ( event->eType == frmOpenEvent )
	{
		frm				= FrmGetActiveForm();

		switch ( packet_type )
		{
			case PF_TEv1	: CtlSetLabel( FrmGetObjectPtr( frm, FrmGetObjectIndex( frm, popupDevices ) ), "TechEdge v1.0" );	break;
			case PF_TEv15	:
			default			: CtlSetLabel( FrmGetObjectPtr( frm, FrmGetObjectIndex( frm, popupDevices ) ), "TechEdge v1.5" );	break;
			case PF_TEv20	: CtlSetLabel( FrmGetObjectPtr( frm, FrmGetObjectIndex( frm, popupDevices ) ), "TechEdge v2.0" );	break;
		}

		LstSetSelection( FrmGetObjectPtr( frm, FrmGetObjectIndex( frm, listDevices ) ), packet_type );

		FrmDrawForm( frm );
		return true;
	}
	else if ( event->eType == ctlSelectEvent )
	{
		if ( event->data.ctlSelect.controlID == buttonHardwareSave )
		{
			frm			= FrmGetActiveForm();
			packet_type	= LstGetSelection( FrmGetObjectPtr( frm, FrmGetObjectIndex( frm, listDevices ) ) );

			DisableSerialHandler();
			switch ( packet_type )
			{
				case PF_TEv1	: packet_length = 1;	packet_crc_pos = 0;		break;
				case PF_TEv15	: packet_length = 12;	packet_crc_pos = 11;	break;
				case PF_TEv20	: packet_length	= 28;	packet_crc_pos = 27;	break;
			}
			EnableSerialHandler();

			Config_Save();
			FrmReturnToForm( 0 );

			return true;
		}
		else if ( event->data.ctlSelect.controlID == buttonHardwareCancel )
		{
			FrmReturnToForm( 0 );
			return true;
		}
	}

	return false;
}

