/*
 * FMDLog
 * Wideband O2 Display/Datalogging Application
 * For the TechEdge DIY-WB series of devices
 * (c) 2002-2003, Jonathan Burchmore
 *
 * Your use of this software is governed by the GNU General Public License, v2.
 * See the file COPYING.txt, or http://www.fsf.org/copyleft/gpl.txt
 *
 * This software is provided with ABSOLUTELY NO WARRANTY.  See the GNU General
 * public license for additional information.
 */

#include <PalmOS.h>
#include "resource.h"
#include "fmdlog.h"

/*
 * Label Dialog
 */

char v1_label[ 10 + 1 ], v2_label[ 10 + 1 ];

Boolean LabelsForm_HandleEvent( EventPtr event )
{
	FormPtr frm;
	FieldPtr v1F, v2F;
	MemHandle v1H, v2H;
	Char *v1p, *v2p;
	char old_v1[ 10 + 1 ], old_v2[ 10 + 1 ];

	if ( event->eType == frmOpenEvent )
	{
		frm	= FrmGetActiveForm();
		v1H	= MemHandleNew( 10 + 1 );
		v2H	= MemHandleNew( 10 + 1 );
		v1p	= MemHandleLock( v1H );
		v2p	= MemHandleLock( v2H );

		StrCopy( v1p, v1_label );
		StrCopy( v2p, v2_label );

		MemHandleUnlock( v1H );
		MemHandleUnlock( v2H );

		v1F	= FrmGetObjectPtr( frm, FrmGetObjectIndex( frm, textLabelVu1 ) );
		v2F	= FrmGetObjectPtr( frm, FrmGetObjectIndex( frm, textLabelVu2 ) );
	
		FldSetText( v1F, v1H, 0, 11 );
		FldSetText( v2F, v2H, 0, 11 );

		FldSetMaxChars( v1F, 10 );
		FldSetMaxChars( v2F, 10 );

		FrmDrawForm( frm );
		return true;
	}
	else if ( event->eType == ctlSelectEvent )
	{
		if ( event->data.ctlSelect.controlID == buttonLabelsSave )
		{
			frm	= FrmGetActiveForm();
			v1F	= FrmGetObjectPtr( frm, FrmGetObjectIndex( frm, textLabelVu1 ) );
			v2F	= FrmGetObjectPtr( frm, FrmGetObjectIndex( frm, textLabelVu2 ) );
			v1p	= FldGetTextPtr( v1F );
			v2p	= FldGetTextPtr( v2F );

			StrCopy( old_v1,	v1_label );
			StrCopy( old_v2,	v2_label );
			
			StrCopy( v1_label,	v1p );
			StrCopy( v2_label,	v2p );

			Config_Save();
			FrmReturnToForm( 0 );

			Erase_Vlabel( old_v1,	U1L_X,	U1L_Y );
			Erase_Vlabel( old_v2,	U2L_X,	U2L_Y );

			Draw_Vlabel( v1_label,	U1L_X,	U1L_Y );
			Draw_Vlabel( v2_label,	U2L_X,	U2L_Y );

			return true;
		}
		else if ( event->data.ctlSelect.controlID == buttonLabelsCancel )
		{
			FrmReturnToForm( 0 );
			return true;
		}
	}

	return false;
}

